local function noncustomdeathchars(p)
	if p.mo.skin ~= "soapthehedge"
	and p.mo.skin ~= "takisthefox"
	and p.mo.skin ~= "adventuresonic"
	and p.mo.skin ~= "mario"
	and p.mo.skin ~= "luigi"
	and p.mo.skin ~= "kris"
    and p.mo.skin ~= "ralsei"
    and p.mo.skin ~= "susie"
	and p.mo.skin ~= "pointy"
	and p.mo.skin ~= "fluffy"
	and p.mo.skin ~= "frank"
	and p.mo.skin ~= "dummie"
	and p.mo.skin ~= "huggert"
	and p.mo.skin ~= "tatails"
	and p.mo.skin ~= "crawla"
	and p.mo.skin ~= "kirby"
	and p.mo.skin ~= "flicky"
	and p.mo.skin ~= "steve"
	and p.mo.skin ~= "sgimario"
	and p.mo.skin ~= "inachair"
	and p.mo.skin ~= "kou"
	and p.mo.skin ~= "dark"
	and p.mo.skin ~= "xkz"
	and p.mo.skin ~= "sunky"
	and p.mo.skin ~= "xsonic"
	and p.mo.skin ~= "xsonicserious"
	and p.mo.skin ~= "doomguy"
	and p.mo.skin ~= "bj"
	and p.mo.skin ~= "milne"
	and p.mo.skin ~= "iclyn"
	and p.mo.skin ~= "crashbandi"
	and p.mo.skin ~= "speccy"
		return true
	else
		return false
	end
end

addHook("MobjDeath", function(target, inflictor, source, damagetype)
	if target.player and target.player.valid
	and target and target.valid
	and inflictor and inflictor.valid
	and noncustomdeathchars(target.player)
	and not (damagetype & DMG_INSTAKILL)
	and not (damagetype & DMG_DEATHPIT)
	and not (damagetype & DMG_CRUSHED)
	and not (damagetype & DMG_DROWNED)
	and not (damagetype & DMG_FIRE)
	and not (damagetype & DMG_ELECTRIC)
		target.state = S_PLAY_PAIN
		target.flags = $ & ~MF_NOGRAVITY
		P_SetObjectMomZ(target, 4*FRACUNIT)
	end
end,MT_PLAYER)

addHook("MobjDeath", function(target, inflictor, source, damagetype)
	if target.player and target.player.valid
	and target and target.valid
	and inflictor and inflictor.valid
	and noncustomdeathchars(target.player)
	and not (damagetype & DMG_INSTAKILL)
	and (damagetype & DMG_FIRE)
		target.state = S_PLAY_PAIN
		target.flags = $ & ~MF_NOGRAVITY
		if P_PlayerTouchingSectorSpecial(target.player, 1, 3)
			target.player.lavadeath = true
		else
			target.player.firedeath = 1
		end
	end
end,MT_PLAYER)

addHook("MobjDeath", function(target, inflictor, source, damagetype)
	if target.player and target.player.valid
	and target and target.valid
	and inflictor and inflictor.valid
	and noncustomdeathchars(target.player)
	and not (damagetype & DMG_INSTAKILL)
	and not (damagetype & DMG_DEATHPIT)
	and not (damagetype & DMG_CRUSHED)
	and (damagetype & DMG_DROWNED or P_InSpaceSector(target))
		target.state = S_PLAY_DRWN
		target.flags = $ & ~MF_NOGRAVITY
		P_SetObjectMomZ(target, 4*FRACUNIT)
	end
end,MT_PLAYER)

addHook("MobjDeath", function(target, inflictor, source, damagetype)
	if target.player and target.player.valid
	and target and target.valid
	and inflictor and inflictor.valid
	and noncustomdeathchars(target.player)
	and (damagetype & DMG_DEATHPIT)
		target.flags = $ & ~MF_NOGRAVITY
		target.flags = $|MF_NOCLIPHEIGHT
		P_SetObjectMomZ(target, -40*FRACUNIT)
		target.state = S_PLAY_PAIN
	end
end,MT_PLAYER)

addHook("MobjDeath", function(target, inflictor, source, damagetype)
	if target.player and target.player.valid
	and target and target.valid
	and inflictor and inflictor.valid
	and noncustomdeathchars(target.player)
	and (damagetype & DMG_DEATHPIT)
		target.flags = $ & ~MF_NOGRAVITY
		target.flags = $|MF_NOCLIPHEIGHT
		P_SetObjectMomZ(target, -40*FRACUNIT)
		target.state = S_PLAY_PAIN
	end
end,MT_PLAYER)

freeslot("S_PLAY_DEADLAND","SPR2_OOF_","S_PLAY_DEADLANDALT","SPR2_SHIT","S_PLAY_DEADLANDDEFAULT", "SKINCOLOR_ROASTED")

spr2defaults[SPR2_OOF_] = SPR2_SHIT
spr2defaults[SPR2_SHIT] = SPR2_PAIN

states[S_PLAY_DEADLAND] = {
	sprite = SPR_PLAY,
	frame = SPR2_OOF_,
	tics = 2,
	nextstate = S_PLAY_DEADLAND
}

states[S_PLAY_DEADLANDALT] = {
	sprite = SPR_PLAY,
	frame = SPR2_SHIT,
	tics = 2,
	nextstate = S_PLAY_DEADLANDALT
}

states[S_PLAY_DEADLANDDEFAULT] = {
	sprite = SPR_PLAY,
	frame = SPR2_PAIN,
	tics = 2,
	nextstate = S_PLAY_DEADLANDDEFAULT
}


local function dostates(p)
	if P_IsValidSprite2(p.mo, SPR2_OOF_)
		p.mo.state = S_PLAY_DEADLAND
	elseif P_IsValidSprite2(p.mo, SPR2_SHIT)
		p.mo.state = S_PLAY_DEADLANDALT
	elseif not P_IsValidSprite2(p.mo, SPR2_OOF_)
	and not P_IsValidSprite2(p.mo, SPR2_SHIT)
		p.mo.state = S_PLAY_DEADLANDDEFAULT
	end
end

addHook("PlayerThink", function(p)
	if p.fakedeadtimer == nil
		p.fakedeadtimer = 0
		p.pitsound = false
		p.firedeath = 0
		p.electricdeath = false
	end
	if p.mo and p.mo.valid
	and p.playerstate == PST_DEAD
		p.fakedeadtimer = $1+1
	end
end)

addHook("PlayerSpawn", function(p)
	p.fakedeadtimer = 0
	p.firedeath = 0
	p.lavadeath = false
	p.fireoverlay = nil
	p.electricdeath = false
	p.electricoverlay = nil
	p.pitsound = false
	p.deathbound = false
end)

local function deathfire(p)
	if leveltime%7 == 0
		local ryx = P_RandomRange(13, -13)
		local fire = P_SpawnMobj(p.mo.x+ryx*FU,p.mo.y+ryx*FU,p.mo.z+ryx*FU,MT_THOK)
		fire.scale = p.mo.scale+FU
		fire.state = S_SPINDUST_FIRE1
	end
end

local function zap(p)
	if leveltime%7 == 0
		local ryx = P_RandomRange(13, -13)
		local zap = P_SpawnMobj(p.mo.x+ryx*FU,p.mo.y+ryx*FU,p.mo.z+ryx*FU,MT_WATERZAP)
		zap.scale = p.mo.scale
		zap.colorized = true
		zap.color = SKINCOLOR_GOLDENROD
	end
end

addHook("ThinkFrame", do
	for p in players.iterate
		if noncustomdeathchars(p)
		and p.playerstate == PST_DEAD
		and not P_CheckDeathPitCollide(p.mo,true)
			p.mo.flags = $ & ~MF_NOCLIPHEIGHT
			p.mo.flags = $ & ~MF_NOGRAVITY
			p.mo.flags2 = $ & ~MF2_DONTDRAW
		end
		if p.playerstate == PST_DEAD
		and noncustomdeathchars(p)
		and (p.mo.state == S_PLAY_PAIN or p.mo.state == S_PLAY_DEAD or p.mo.state == S_PLAY_DRWN)
		and (P_IsObjectOnGround(p.mo) or p.mo.eflags & MFE_JUSTHITFLOOR)
		and not p.electricdeath
		and not P_CheckDeathPitCollide(p.mo,true)
			dostates(p)
			p.deathbound = false
			p.mo.rollangle = 0
			S_StartSound(p.mo, sfx_s3k96)
			P_InstaThrust(p.mo,p.drawangle,0*FRACUNIT)
		end
		if p.playerstate == PST_DEAD
		and noncustomdeathchars(p)
		and P_CheckDeathPitCollide(p.mo, true)
			p.mo.flags = $|MF_NOCLIPHEIGHT
			p.deathbound = false
			P_SetObjectMomZ(p.mo, -40*FRACUNIT)
		end
		if p.playerstate == PST_DEAD
		and p.mo.state == S_PLAY_DEAD
		and (p.mo.eflags & MFE_UNDERWATER)
			p.mo.state = S_PLAY_DRWN
		end
		if p.playerstate == PST_DEAD
		and noncustomdeathchars(p)
		and P_CheckDeathPitCollide(p.mo, true)
		and not p.pitsound
			p.pitsound = true
			S_StartSound(p.mo, sfx_s3k51)
		end
		if p.playerstate == PST_DEAD
		and noncustomdeathchars(p)
		and not P_IsObjectOnGround(p.mo)
		and not (p.mo.eflags & MFE_JUSTHITFLOOR)
		and not (p.mo.eflags & MFE_GOOWATER)
		and p.fakedeadtimer < 30
			p.deadtimer = 0*TICRATE
		end
		if p.firedeath == 1
			p.mo.state = S_PLAY_PAIN
			P_InstaThrust(p.mo, p.drawangle, -7*FU)
			p.firedeath = 2
		end
		if P_PlayerTouchingSectorSpecial(p, 1, 3)
		and p.playerstate == PST_DEAD
			p.lavadeath = true
		end
		if p.firedeath >= 1
			deathfire(p)
		end
		if (p.firedeath >= 1 or p.lavadeath)
		and not p.fireoverlay
			p.fireoverlay = P_SpawnMobj(p.mo.x,p.mo.y,p.mo.z,MT_OVERLAY)
			p.fireoverlay.target = p.mo
			p.fireoverlay.skin = p.mo.skin
			p.fireoverlay.sprite = p.mo.sprite
			p.fireoverlay.sprite2 = p.mo.sprite2
			p.fireoverlay.rollangle = p.mo.rollangle
			p.fireoverlay.scale = p.mo.scale
			p.fireoverlay.state = p.mo.state
			p.fireoverlay.color = SKINCOLOR_SILVER
			p.fireoverlay.colorized = true
			p.fireoverlay.spritexscale = p.mo.spritexscale
			p.fireoverlay.spriteyscale = p.mo.spriteyscale
			p.fireoverlay.angle = p.drawangle
		end
		if p.fireoverlay and p.fireoverlay.valid
			p.fireoverlay.rollangle = p.mo.rollangle
			p.fireoverlay.scale = p.mo.scale
			p.fireoverlay.state = p.mo.state
			p.fireoverlay.angle = p.drawangle
			p.fireoverlay.spritexscale = p.mo.spritexscale
			p.fireoverlay.spriteyscale = p.mo.spriteyscale
		end
		if p.lavadeath
			P_SetObjectMomZ(p.mo, -FU)
			p.mo.flags = $|MF_NOCLIPHEIGHT
			deathfire(p)
		end
		if (p.lavadeath or p.firedeath >= 1)
		and not S_SoundPlaying(p.mo, sfx_s3kc2l)
			S_StartSound(p.mo, sfx_s3kc2l)
		end
		if p.electricdeath
		and not S_SoundPlaying(p.mo, sfx_buzz1)
			S_StartSound(p.mo, sfx_buzz1)
		end
		if P_PlayerTouchingSectorSpecial(p, 1, 4)
		and p.playerstate == PST_DEAD
		and p.firedeath == 0
			p.electricdeath = true
		end
		if p.electricdeath
			p.mo.state = S_PLAY_DEAD
			p.mo.momx = 0
			p.mo.momy = 0
			p.mo.momz = 0
			P_SetObjectMomZ(p.mo, 0*FU)
			zap(p)
			p.mo.rollangle = 0
			p.mo.flags = $ & ~MF_NOGRAVITY
		end
		if p.electricdeath
		and not p.electricoverlay
			p.electricoverlay = P_SpawnMobj(p.mo.x,p.mo.y,p.mo.z,MT_OVERLAY)
			p.electricoverlay.target = p.mo
			p.electricoverlay.skin = p.mo.skin
			p.electricoverlay.sprite = p.mo.sprite
			p.electricoverlay.sprite2 = p.mo.sprite2
			p.electricoverlay.rollangle = p.mo.rollangle
			p.electricoverlay.scale = p.mo.scale
			p.electricoverlay.state = p.mo.state
			p.electricoverlay.color = SKINCOLOR_SILVER
			p.electricoverlay.colorized = true
			p.electricoverlay.spritexscale = p.mo.spritexscale
			p.electricoverlay.spriteyscale = p.mo.spriteyscale
			p.electricoverlay.angle = p.drawangle
		end
		if p.electricoverlay and p.electricoverlay.valid
			p.electricoverlay.rollangle = p.mo.rollangle
			p.electricoverlay.scale = p.mo.scale
			p.electricoverlay.state = p.mo.state
			p.electricoverlay.angle = p.drawangle
			p.electricoverlay.spritexscale = p.mo.spritexscale
			p.electricoverlay.spriteyscale = p.mo.spriteyscale
			if leveltime%3 == 0
			and p.electricoverlay.color == SKINCOLOR_BONE
				p.electricoverlay.color = SKINCOLOR_JET
			elseif leveltime%3 == 0
			and p.electricoverlay.color == SKINCOLOR_JET
				p.electricoverlay.color = SKINCOLOR_BONE
			end
		end
	end
end)


addHook("ThinkFrame", do
	for p in players.iterate
		if p.thrustplayer == nil
			p.thrustplayer = false
		end
		if noncustomdeathchars(p)
		and p.playerstate == PST_DEAD
		and p.mo and p.mo.valid
		and not p.thrustplayer
		and not P_CheckDeathPitCollide(p.mo, true)
		and not P_InSpaceSector(p.mo)
		and not p.powers[pw_underwater]
		and p.firedeath == 0
		and not p.lavadeath
			P_InstaThrust(p.mo, p.drawangle, -40*FRACUNIT)
			p.mo.state = S_PLAY_PAIN
			p.thrustplayer = true
		end
		if p.playerstate == PST_LIVE
			p.thrustplayer = false
		end
		if P_CheckDeathPitCollide(p.mo, true)
			p.mo.state = S_PLAY_PAIN
			P_SetObjectMomZ(p.mo, -40*FRACUNIT)
		end
	end
end)

addHook("PlayerThink", function(p)
	if p.rerollangle == nil
		p.rerollangle = 0
		p.spacereangle = 0
	end
	if noncustomdeathchars(p)
	and p.mo.state == S_PLAY_PAIN
	and p.playerstate == PST_DEAD
	and not P_CheckDeathPitCollide(p.mo, true)
		p.mo.rollangle = p.rerollangle
		p.rerollangle = $+ANG10
	end
	if noncustomdeathchars(p)
	and p.mo.state == S_PLAY_DRWN
	and p.mo and p.mo.valid
	and P_InSpaceSector(p.mo)
		p.mo.momz = 0
		if leveltime%5 == 0
			p.mo.rollangle = p.spacereangle
			p.spacereangle = $+ANG2
		end
	end
end)

addHook("MobjMoveBlocked", function(mo)
	if mo and mo.valid
	and mo.player and mo.player.valid
	and mo.player.playerstate == PST_DEAD
	and not P_InSpaceSector(mo)
	and not mo.player.lavadeath
	and mo.player.firedeath == 0
	and not (mo.eflags & MFE_UNDERWATER)
	and not P_CheckDeathPitCollide(mo, true)
		S_StartSound(mo, sfx_s3k9e)
		P_SetObjectMomZ(mo, 10*FU)
		mo.player.deathbound = true
		mo.state = S_PLAY_DRWN
		P_InstaThrust(mo, mo.player.drawangle, 7*FU)
	end
end, MT_PLAYER)

addHook("PlayerThink", function(p)
	if p.boundangle == nil
		p.boundangle = 0
	end
	if p.mo and p.mo.valid
	and p.deathbound
	and not P_CheckDeathPitCollide(p.mo, true)
		p.mo.rollangle = p.boundangle
		p.boundangle = $+ANG15
	end
end)

skincolors[SKINCOLOR_ROASTED] = {
    name = "Roasted",
    ramp = {11,13,14,18,19,20,21,22,23,24,25,26,27,28,29,30},
    invcolor = SKINCOLOR_WHITE,
    invshade = 5,
    chatcolor = V_GREYMAP,
    accessible = true
}